Loading...
Searching...
No Matches
Opm::WaterPvtThermal< Scalar, enableBrine > Class Template Reference

This class implements temperature dependence of the PVT properties of water. More...

`#include <WaterPvtThermal.hpp>`

## Public Types

using | TabulatedOneDFunction = Tabulated1DFunction<Scalar>
using | IsothermalPvt = WaterPvtMultiplexer<Scalar, false, enableBrine>

## Public Member Functions

WaterPvtThermal (IsothermalPvt *isothermalPvt, const std::vector< Scalar > &viscrefPress, const std::vector< Scalar > &watdentRefTemp, const std::vector< Scalar > &watdentCT1, const std::vector< Scalar > &watdentCT2, const std::vector< Scalar > &watJTRefPres, const std::vector< Scalar > &watJTC, const std::vector< Scalar > &pvtwRefPress, const std::vector< Scalar > &pvtwRefB, const std::vector< Scalar > &pvtwCompressibility, const std::vector< Scalar > &pvtwViscosity, const std::vector< Scalar > &pvtwViscosibility, const std::vector< TabulatedOneDFunction > &watvisctCurves, const std::vector< TabulatedOneDFunction > &internalEnergyCurves, bool enableThermalDensity, bool enableJouleThomson, bool enableThermalViscosity, bool enableInternalEnergy)

| WaterPvtThermal (const WaterPvtThermal &data)
void | setNumRegions (std::size_t numRegions)
| Set the number of PVT-regions considered by this object.
void | setVapPars (const Scalar par1, const Scalar par2)
void | initEnd ()
| Finish initializing the thermal part of the water phase PVT properties.
bool | enableThermalDensity () const
| Returns true iff the density of the water phase is temperature dependent.
bool | enableJouleThomson () const
| Returns true iff Joule-Thomson effect for the water phase is active.
bool | enableThermalViscosity () const
| Returns true iff the viscosity of the water phase is temperature dependent.
Scalar | hVap (unsigned regionIdx) const
std::size_t | numRegions () const
template<class Evaluation>
Evaluation | internalEnergy (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rsw, const Evaluation &saltconcentration) const
| Returns the specific internal energy [J/kg] of water given a set of parameters.
template<class Evaluation>
Evaluation | viscosity (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rsw, const Evaluation &saltconcentration) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
Evaluation | saturatedViscosity (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &saltconcentration) const
| Returns the dynamic viscosity [Pa s] of the fluid phase given a set of parameters.
template<class Evaluation>
Evaluation | saturatedInverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &saltconcentration) const
| Returns the formation volume factor [-] of the fluid phase.
template<class Evaluation>
Evaluation | inverseFormationVolumeFactor (unsigned regionIdx, const Evaluation &temperature, const Evaluation &pressure, const Evaluation &Rsw, const Evaluation &saltconcentration) const
| Returns the formation volume factor [-] of the fluid phase.
template<class FluidState, class LhsEval = typename FluidState::Scalar>
std::pair< LhsEval, LhsEval > | inverseFormationVolumeFactorAndViscosity (const FluidState &fluidState, unsigned regionIdx)
| Returns the formation volume factor [-] and viscosity [Pa s] of the fluid phase.
template<class Evaluation>
Evaluation | saturationPressure (unsigned, const Evaluation &, const Evaluation &, const Evaluation &) const
| Returns the saturation pressure of the water phase [Pa] depending on its mass fraction of the gas component.
template<class Evaluation>
Evaluation | saturatedGasDissolutionFactor (unsigned, const Evaluation &, const Evaluation &, const Evaluation &) const
| Returns the gas dissolution factor [m^3/m^3] of the water phase.
template<class Evaluation>
Evaluation | diffusionCoefficient (const Evaluation &, const Evaluation &, unsigned) const
const IsothermalPvt * | isoThermalPvt () const
Scalar | waterReferenceDensity (unsigned regionIdx) const
const std::vector< Scalar > & | viscrefPress () const
const std::vector< Scalar > & | watdentRefTemp () const
const std::vector< Scalar > & | watdentCT1 () const
const std::vector< Scalar > & | watdentCT2 () const
const std::vector< Scalar > & | pvtwRefPress () const
const std::vector< Scalar > & | pvtwRefB () const
const std::vector< Scalar > & | pvtwCompressibility () const
const std::vector< Scalar > & | pvtwViscosity () const
const std::vector< Scalar > & | pvtwViscosibility () const
const std::vector< TabulatedOneDFunction > & | watvisctCurves () const
const std::vector< TabulatedOneDFunction > & | internalEnergyCurves () const
bool | enableInternalEnergy () const
const std::vector< Scalar > & | watJTRefPres () const
const std::vector< Scalar > & | watJTC () const
bool | operator== (const WaterPvtThermal< Scalar, enableBrine > &data) const
WaterPvtThermal< Scalar, enableBrine > & | operator= (const WaterPvtThermal< Scalar, enableBrine > &data)

## Detailed Description

template<class Scalar, bool enableBrine>
class Opm::WaterPvtThermal< Scalar, enableBrine >

This class implements temperature dependence of the PVT properties of water.

Note that this only implements the temperature part, i.e., it requires the isothermal properties as input.

## Member Function Documentation

## saturationPressure()

template<class Scalar, bool enableBrine>
template<class Evaluation>

Evaluation Opm::WaterPvtThermal< Scalar, enableBrine >::saturationPressure | ( | unsigned | ,
|  | const Evaluation & | ,
|  | const Evaluation & | ,
|  | const Evaluation & | ) const

inline

Returns the saturation pressure of the water phase [Pa] depending on its mass fraction of the gas component.

Parameters

  Rs | The surface volume of gas component dissolved in what will yield one cubic meter of oil at the surface [-]

The documentation for this class was generated from the following files:

- opm/material/fluidsystems/blackoilpvt/WaterPvtThermal.hpp
- opm/material/fluidsystems/blackoilpvt/WaterPvtThermal.cpp